import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.neighbors import KNeighborsClassifier
import matplotlib.pyplot as plt
from matplotlib.colors import ListedColormap

D = np.loadtxt( "datos.txt" )
X = D[:,0:2]
y = D[:,2]

# El modelo de la red

# 2 x 12
W2 = np.array([[ 11.86171409, -15.15755316,   1.09702603,  -0.95129379,
          5.97425591,  -2.14735402,  -2.90775572,   1.92577566,
         -4.56768294,   2.59833163,   3.9295905 ,   5.70982484],
       [ 14.56847243,  -4.74837006, -11.20252592,  -5.97536991,
        -15.04031543,   2.25098896,  -4.24432423,  -7.69319005,
         -3.01021304,  -7.03894114,  -4.4101032 , -18.11467687]])

# 12x1
W3 = np.array([[  4.00162693],
       [ 13.08492736],
       [  1.86641083],
       [ -1.09562262],
       [-10.18547423],
       [ -4.10493815],
       [-11.90019953],
       [ -4.78340107],
       [ -4.44735009],
       [  6.44714071],
       [  2.43727813],
       [  8.72683537]])

vs2 = np.array([  9.48942416,   9.54371401,   5.78342949,  -0.58850859,
       -12.21732708,  -1.31044688,  13.87846389,  -2.93828933,
        -3.3796991 ,   4.23561423,   0.4964591 ,  29.40946231])

vs3 = np.array([-29.67781231])

def evalua( x ) :
	#           1x2 2x12 = 1x12  
	s2 = np.tanh( x @ W2 + vs2 )
	s3 = s2 @ W3 + vs3 

	v = 1/(1+np.exp(-s3) )
	if v < 0.5 :
		return 0 
	else :
		return 1
#########################################################################

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=2 )

# Hacemos la gráfica de la superficie de decisión
# En x,y \in [-2,2]
n = 100
vx = np.linspace( -1.1, 1.1, n )
vy = np.linspace( -1.1, 1.1, n )

x, y = np.meshgrid( vx, vy )
Z = np.zeros( (n,n) )

va = np.zeros( (1,2) )

for i in range(n):
	for j in range(n):
		va[0,0]  = x[j,i]
		va[0,1]  = y[j,i]
		Z[j,i] = evalua( va )


fig, ax = plt.subplots()

cm = plt.cm.RdBu
cm_bright = ListedColormap(['#FF0000', '#0000FF'])

ax.contourf( x, y, Z, cmap=cm, alpha=.8 )
ax.set_aspect(1)
# ax.scatter( decision.Vs[:,0], decision.Vs[:,1] )
# ax.set_xticks(())
# ax.set_yticks(())
ax.scatter( X_entrena[:,0], X_entrena[:,1], c=y_entrena, cmap=cm_bright, edgecolors='k' )
ax.scatter( X_prueba[:,0], X_prueba[:,1], marker='x', c=y_prueba, cmap=cm_bright, edgecolors='k' )

plt.show( )

